print("ElementalRebalance loaded\n")

local StaticDamageTextClass = nil
local function InitDamageTextBaseClass()
    if StaticDamageTextClass == nil or not StaticDamageTextClass:IsValid() then
        StaticDamageTextClass = StaticFindObject("/Script/Pal.PalUIDamageTextBase")
        if StaticDamageTextClass ~= nil and StaticDamageTextClass:IsValid() then
			-- print("Text Class Loaded")
		end
	end
end
InitDamageTextBaseClass()

local AttackType = 0
local UpdatedDamage = 0
local TextWidget = nil

RegisterHook("/Script/Pal.PalDamageReactionComponent:ProcessDamage_ToServer", function(Context, Info)
	-- print("Logging attack type")
	AttackType = Info:get().AttackElementType
end)

RegisterHook("/Script/Pal.PalDamageReactionComponent:ApplyDamageForHP", function(Context, Result)
	-- print("Calculating damage")
	DefendType1 = Result:get().Defender.CharacterParameterComponent.ElementType1
	DefendType2 = Result:get().Defender.CharacterParameterComponent.ElementType2
	-- print("Original damage: " .. tostring(Result:get().Damage))
	-- Neutral
	if AttackType == 1 then
		-- Resisted by Neutral
		if DefendType1 == 1 or DefendType2 == 1 then
			Result:get().Damage = math.floor(Result:get().Damage / 2.0)
		end
		-- Remove resisted by Dark
		if DefendType1 == 8 or DefendType2 == 8 then
			Result:get().Damage = Result:get().Damage * 2
		end
	end
	-- Fire
	if AttackType == 2 then
		-- Resisted by Dark
		if DefendType1 == 8 or DefendType2 == 8 then
			Result:get().Damage = math.floor(Result:get().Damage / 2.0)
		end
	end
	-- Water
	if AttackType == 3 then
		-- Strong against Dragon
		if DefendType1 == 9 or DefendType2 == 9 then
			Result:get().Damage = Result:get().Damage * 2
		end
		-- Resisted by Ice
		if DefendType1 == 6 or DefendType2 == 6 then
			Result:get().Damage = math.floor(Result:get().Damage / 2.0)
		end
	end
	-- Grass
	if AttackType == 4 then
		-- Strong against Electric
		if DefendType1 == 5 or DefendType2 == 5 then
			Result:get().Damage = Result:get().Damage * 2
		end
		-- Resisted by Dark
		if DefendType1 == 8 or DefendType2 == 8 then
			Result:get().Damage = math.floor(Result:get().Damage / 2.0)
		end
	end
	-- Electric
	if AttackType == 5 then
		-- Strong against Dark
		if DefendType1 == 8 or DefendType2 == 8 then
			Result:get().Damage = Result:get().Damage * 2
		end
		-- Resisted by Grass
		if DefendType1 == 4 or DefendType2 == 4 then
			Result:get().Damage = math.floor(Result:get().Damage / 2.0)
		end
	end
	-- Ice
	if AttackType == 6 then
		-- Strong against Water
		if DefendType1 == 3 or DefendType2 == 3 then
			Result:get().Damage = Result:get().Damage * 2
		end
		-- Resisted by Ground
		if DefendType1 == 7 or DefendType2 == 7 then
			Result:get().Damage = math.floor(Result:get().Damage / 2.0)
		end
	end
	-- Ground
	if AttackType == 7 then
		-- Strong against Ice
		if DefendType1 == 6 or DefendType2 == 6 then
			Result:get().Damage = Result:get().Damage * 2
		end
		-- Resisted by Dragon
		if DefendType1 == 9 or DefendType2 == 9 then
			Result:get().Damage = math.floor(Result:get().Damage / 2.0)
		end
	end
	-- Dark
	if AttackType == 8 then
		-- Strong against Fire
		if DefendType1 == 2 or DefendType2 == 2 then
			Result:get().Damage = Result:get().Damage * 2
		end
		-- Resisted by Electric
		if DefendType1 == 5 or DefendType2 == 5 then
			Result:get().Damage = math.floor(Result:get().Damage / 2.0)
		end
		-- Remove strong against Neutral
		if DefendType1 == 1 or DefendType2 == 1 then
			Result:get().Damage = math.floor(Result:get().Damage / 2.0)
		end
	end
	-- Dragon
	if AttackType == 9 then
		-- Strong against Ground
		if DefendType1 == 7 or DefendType2 == 7 then
			Result:get().Damage = Result:get().Damage * 2
		end
		-- Resisted by Water
		if DefendType1 == 3 or DefendType2 == 3 then
			Result:get().Damage = math.floor(Result:get().Damage / 2.0)
		end
	end
	-- print("Rebalanced damage: " .. tostring(Result:get().Damage))
	UpdatedDamage = Result:get().Damage
	TextWidget.SetDamageValue(UpdatedDamage)
end)

NotifyOnNewObject("/Script/Pal.PalUserWidget", function(Widget)
	if StaticDamageTextClass ~= nil and StaticDamageTextClass:IsValid() and Widget:IsA(StaticDamageTextClass) then
		TextWidget = Widget
	end
end)
